// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

var CFGPO_PROPERTY                = 0x00000001
var CFGOP_CONFIGITEM              = 0x00000002
var CFGOP_CONFIGITEMEX            = 0x00000004

var ASWM_FNTYPE_NONE                = 0;
var ASWM_FNTYPE_CV                  = 1;
var ASWM_FNTYPE_CV_FWL              = 2;
var ASWM_FNTYPE_CV_FWL_FWH          = 3;
var ASWM_FNTYPE_CTV_FWL_FWH         = 4;
var ASWM_FNTYPE_CV_FWH              = 5;

var ASWM_HEALTH_STAUTS_NORMAL       = 0x0000;
var ASWM_HEALTH_STATUS_WARNING		= 0x0001;
var ASWM_HEALTH_STATUS_FATAL		= 0x0002;
var ASWM_HEALTH_STATUS_NONRECOVER	= 0x0004;
var ASWM_HEALTH_FLAG_NONE		    = 0x0000;
var ASWM_HEALTH_FLAG_LOW		    = 0x0100;
var ASWM_HEALTH_FLAG_HIGH		    = 0x0200;

var ASWM_HEALTH_NORMAL		        = (ASWM_HEALTH_FLAG_NONE|ASWM_HEALTH_STAUTS_NORMAL);
var ASWM_HEALTH_WARNING		        = (ASWM_HEALTH_FLAG_NONE|ASWM_HEALTH_STATUS_WARNING);
var ASWM_HEALTH_FATAL		        = (ASWM_HEALTH_FLAG_NONE|ASWM_HEALTH_STATUS_FATAL);
var ASWM_HEALTH_FATALLOW	        = (ASWM_HEALTH_FLAG_LOW| ASWM_HEALTH_STATUS_FATAL);
var ASWM_HEALTH_WARNINGLOW	        = (ASWM_HEALTH_FLAG_LOW| ASWM_HEALTH_STATUS_WARNING);
var ASWM_HEALTH_FATALHIGH	        = (ASWM_HEALTH_FLAG_HIGH|ASWM_HEALTH_STATUS_FATAL);
var ASWM_HEALTH_WARNINGHIGH	        = (ASWM_HEALTH_FLAG_HIGH|ASWM_HEALTH_STATUS_WARNING);

function isdecimal (x)
{
    var s = "0123456789", j = 0;

    if (x.length == 0)
            return false;

    if (x.charAt(0) == '+' || x.charAt(0) == '-') {
        j = 1;
    }

    for (var i = j; i < x.length; i++) {
        if (s.indexOf(x.charAt(i)) == -1)
            return false;
    }
    return true;
}


function maximum ()
{
    var m = Number.NEGATIVE_INFINITY;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i] > m) {
            m = arguments[i];
        }
    }
    return m;
}

function minimum ()
{
    var m = Number.POSITIVE_INFINITY;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i] < m) {
            m = arguments[i];
        }
    }
    return m;
}


//////////////////////////////////////////////////////////////////////
// GSysViewHealth

function GSysViewHealth (view)
{
    this.view = view;
    this.ids = new Array ();
    this.values = new Array ();
    var j = this.ids.length;
    for (var i = 1; i < arguments.length; i += 2, j++) {
        this.ids[j] = arguments[i];
        this.values[j.toString() + ',' + arguments[i]] = arguments[i + 1];
    }
}


//////////////////////////////////////////////////////////////////////
// Sensor

function Sensor (id, datetime, unit, functype, configflag, currVal, fatallo, warnlo, fatalhi, warnhi, prevStatus, currStatus, eventTime, name, theoryvalue, configitem, property)
{
    this.id = id;
    this.datetime = datetime;
    this.unit = unit;
    this.functype = functype;
    this.configflag = configflag;
    this.currvalue = currVal;
    this.fatallow = fatallo;
    this.warninglow = warnlo;
    this.fatalhigh = fatalhi;
    this.warninghigh = warnhi;
    this.prevstatus = prevStatus;
    this.currstatus = currStatus;
    this.eventtime = eventTime;
    this.internalname = name;
    this.theoryvalue = theoryvalue;
    this.configitem = configitem;
    this.property = property;
}


//////////////////////////////////////////////////////////////////////
// miniSensor

function miniSensor (id, unit, functype, currVal, fatallo, warnlo, fatalhi, warnhi, currstatus, name, theoryvalue)
{
    this.id = id;
    this.unit = unit;
    this.functype = functype;
    this.currvalue = currVal;
    this.fatallow = fatallo;
    this.warninglow = warnlo;
    this.fatalhigh = fatalhi;
    this.warninghigh = warnhi;
    this.currstatus = currstatus;
    this.internalname = name;
    this.theoryvalue = theoryvalue;
}


//////////////////////////////////////////////////////////////////////
// tinySensor

function tinySensor (id, gid, functype, currVal, currStatus, prevStatus, eventTime, unit, name)
{
    this.id = id;
    this.gid = gid;
    this.functype = functype;
    this.currvalue = currVal;
    this.currstatus = currStatus;
    this.prevstatus = prevStatus;
    this.eventtime = eventTime;
    this.unit = unit;
    this.internalname = name;
}


//////////////////////////////////////////////////////////////////////
// SensorGroup

function SensorGroup (id, prevStatus, currStatus, sensorCount, cfgFlag)
{
    this.id = id;
    this.prevstatus = prevStatus;
    this.currStatus = currStatus;
    this.sensorCount = sensorCount;
    this.configFlag = cfgFlag;
}


//////////////////////////////////////////////////////////////////////
// DiskGroup

function DiskGroup (id, property, sensors)
{
    this.id = id;
    this.property = property;
    this.sensors = sensors;
}


//////////////////////////////////////////////////////////////////////
// Housekeep

function getSnsrHealthDescEx (snsr, delimit)
{
    if (!snsr)
        return;

    var sid = snsr.id;
    var i = snsr.currvalue;
    var j = snsr.currstatus;

    if (parent.tblSeqResources[sid]) {
        if (parent.tblSeqResources[sid][i])
            return parent.tblSeqResources[sid][i];
        return parent.I18N['NO_PROBLEM_DETECTED'];
    } else
    if (parent.tblBtfResources[sid]) {
        var s = '', v;
        for (var k = 0, b = 1; k < 32; k++, b <<= 1) {
            if ((v = parent.tblBtfResources[sid][b])) {
                if (i & b) {
                    s += parent.tblBtfResources[sid][b] + delimit;
                }
            }
        }
        if (s.length > 0)
            return s;
        return parent.I18N['NO_PROBLEM_DETECTED'];
    } else {
        return parent.once.GSensorStatus[j];
    }

    return '';
}
