// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

function isnumber (x)
{
    var s = "0123456789", j = 0;

    if (x.length == 0)
            return false;

    for (var i = j; i < x.length; i++) {
        if (s.indexOf(x.charAt(i)) == -1)
            return false;
    }
    return true;
}

//////////////////////////////////////////////////////////////////////
// pair

function pair (key, value)
{
    this.key = key;
    this.value = value;
}

//////////////////////////////////////////////////////////////////////
// triple

function triple (key, value, extra)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
}

//////////////////////////////////////////////////////////////////////
// quadruple

function quadruple (key, value, extra, other)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
}

//////////////////////////////////////////////////////////////////////
// quintuple

function quintuple (key, value, extra, other, misc)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
    this.misc = misc;
}

//////////////////////////////////////////////////////////////////////
// sexatuple

function sexatuple (key, value, extra, other, misc, more)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
    this.misc = misc;
    this.more = more;
}


//////////////////////////////////////////////////////////////////////
// Tuple

function Tuple ()
{
    this.list = false;
    if (arguments.length > 0) {
        this.list = new Array ();
    }
    var j = this.list.length;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i]) {
            this.list[j++] = arguments[i];
        }
    }
}

function addItemIntoTuple ()
{
    if (!this.list && arguments.length > 0) {
        this.list = new Array ();
    }
    var j = this.list.length;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i]) {
            this.list[j++] = arguments[i];
        }
    }
}

function atCompInTuple (id, compf)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (compf(this.list[i],id)) {
                return this.list[i];
            }
        }
    }
    return false;
}

function atTuple (i)
{
    if (this.list) {
        return this.list[i];
    }
    return false;
}

function lengthOfTuple ()
{
    if (this.list) {
        return this.list.length;
    }
    return 0;
}

function idAtOfTuple (id)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].id == id) {
                return this.list[i];
            }
        }
    }
    return false;
}

function keyAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i];
            }
        }
    }
    return false;
}

function evalAtOfTuple (target, field)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (eval('this.list[i].' + field)) {
                if (eval('this.list[i].' + field) == target) {
                    return this.list[i];
                }
            }
        }
    }
    return false;
}

function pairAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i].value;
            }
        }
    }
    return false;
}

function tripleExtraAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i].extra;
            }
        }
    }
    return false;
}

function quadrupleOtherAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i].other;
            }
        }
    }
    return false;
}

function quintupleMiscAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i].misc;
            }
        }
    }
    return false;
}

function sexatupleMoreAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i].more;
            }
        }
    }
    return false;
}

function pairAtPassOfTuple (key, pass)
{
    if (this.list && pass > 0) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                pass--;
                if (pass == 0) {
                    return this.list[i].value;
                }
            }
        }
    }
    return false;
}

function pairKeyTotalOfTuple (key)
{
    var total = 0;
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                total++;
            }
        }
    }
    return total;
}


function sortTuple (func)
{
    if (this.list) {
        this.list.sort(func);
    }
}


Tuple.prototype.addItem = addItemIntoTuple;
Tuple.prototype.length = lengthOfTuple;
Tuple.prototype.atComp = atCompInTuple;
Tuple.prototype.at = atTuple;
Tuple.prototype.idAt = idAtOfTuple;
Tuple.prototype.keyAt = keyAtOfTuple;
Tuple.prototype.evalAt = evalAtOfTuple;

Tuple.prototype.pairAt = pairAtOfTuple;
Tuple.prototype.pairAtPass = pairAtPassOfTuple;
Tuple.prototype.pairKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.tripleValueAt = pairAtOfTuple;
Tuple.prototype.tripleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.tripleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.tripleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.quadrupleValueAt = pairAtOfTuple;
Tuple.prototype.quadrupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.quadrupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.quadrupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.quadrupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.quintupleValueAt = pairAtOfTuple;
Tuple.prototype.quintupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.quintupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.quintupleMiscAt = quintupleMiscAtOfTuple;
Tuple.prototype.quintupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.quintupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.sexatupleValueAt = pairAtOfTuple;
Tuple.prototype.sexatupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.sexatupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.sexatupleMiscAt = quintupleMiscAtOfTuple;
Tuple.prototype.sexatupleMoreAt = sexatupleMoreAtOfTuple;
Tuple.prototype.sexatupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.sexatupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.sort = sortTuple;